SystemOrganization addCategory: #'ICU-V2-Base'!

ByteString variableByteSubclass: #ICUString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

ICUString variableByteSubclass: #Utf16String
	instanceVariableNames: ''
	classVariableNames: 'EmptyString'
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

!Utf16String class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/9/2012 15:14'!
emptyString

	^EmptyString ifNil: [ EmptyString := Utf16String new ].
	! !

!Utf16String class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/7/2012 17:54'!
fromByteArray: aByteArray size: numberOfEntries
	"
	
	
		'1' asUtf16String
	"
	
	| newInstance |
	
	newInstance := self new: numberOfEntries.
	newInstance 
		replaceFrom: 1 to: numberOfEntries*2 with: aByteArray startingAt: 1.
	^newInstance
! !

!Utf16String class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/8/2012 14:52'!
fromExternalAddress: externalLocation size: numberOfEntries
	| newInstance |
	
	newInstance := self new: numberOfEntries.
	
	NativeBoost memCopy: externalLocation to: newInstance  size: (numberOfEntries*2).
	
	^newInstance! !

!Utf16String class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/7/2012 10:44'!
new: numberOfElements

	^super new: (numberOfElements * 2)! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:07'!
asByteString
	"^<ByteString>"
	
	^UConverter iso88591Converter fromUnicode: self! !

!Utf16String methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/4/2012 11:01'!
asUtf16String 

	^self! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:10'!
asUtf8String
	"^<Utf8String>"
	
	^UConverter utf8Converter fromUnicode: self! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 18:07'!
at: index

	^ Character value: ((self byteAt: index*2 - 1) + ((self byteAt: index*2) << 8))! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 11:21'!
at: index put: aCharacter

	super byteAt: (index*2 - 1) put: aCharacter asInteger \\ 256.
	super byteAt: (index*2) put: aCharacter asInteger >> 8.
	
	^ aCharacter! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 19:02'!
byteSize

	^ super size  ! !

!Utf16String methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 10:29'!
size

	^ super size / 2! !

ICUString variableByteSubclass: #Utf32String
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

ICUString variableByteSubclass: #Utf8String
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

!Utf8String methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/11/2012 23:02'!
asByteString
	"^<ByteString> does a conversion from UTF-8 to current system code page"
	
	| utf16String byteString  |
	
	utf16String := UConverter utf8Converter toUnicode: self.
	byteString := UConverter defaultConverter fromUnicode: utf16String.
	^byteString! !

!Utf8String methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/9/2012 22:09'!
asUtf16String
	"^<Utf16String>"
	
	^UConverter utf8Converter toUnicode: self! !

!Utf8String methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/9/2012 22:08'!
asUtf8String
	"^<Utf8String>"
	
	^self! !

!Character class methodsFor: '*ICU-V2-Base' stamp: 'MartenFeldtmann 9/11/2012 10:58'!
uCharFromName: aString nameChoice: choiceName
	"^<Character> Retrieve the name of a Unicode character.

			
			()Character uFromCharName: 'LATIN CAPITAL LETTER A' nameChoice: 0 ) = $A
	
	
	"
	^ICULibrary interfaceClass uCharFromName: aString nameChoice: choiceName! !

!Character class methodsFor: '*ICU-V2-Base' stamp: 'MartenFeldtmann 9/11/2012 07:27'!
uCodePoint: anInteger 
	"Just for ANSI Compliance"	
	^self value: anInteger! !

!Character class methodsFor: '*ICU-V2-Base' stamp: 'MartenFeldtmann 9/11/2012 10:31'!
uForDigit: digitValue radix: radix
	"^<Character>
Determines the character representation for a specific digit in the specified radix.

If the value of radix is not a valid radix, or the value of digit is not a valid digit in the 
specified radix, the null character (U+0000) is returned.

The radix argument is valid if it is greater than or equal to 2 and less than or equal to 36. 
The digit argument is valid if 0 <= digit < radix.

If the digit is less than 10, then '0' + digit is returned. Otherwise, the value 'a' + digit - 10 
is returned.	
	
	
	"
	^ICULibrary interfaceClass uForDigit: digitValue radix: radix! !

!UndefinedObject methodsFor: '*ICU-V2-Base' stamp: 'MartenFeldtmann 9/5/2012 21:58'!
asUtf16String

	^nil! !

Error subclass: #ExICUError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

Object subclass: #ICULibrary
	instanceVariableNames: ''
	classVariableNames: 'InterfaceClass'
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

!ICULibrary class methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 16:22'!
interfaceClass

	^InterfaceClass ! !

!ICULibrary class methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 16:24'!
interfaceClass: value

	InterfaceClass := value! !

SharedPool subclass: #ICUV2Constants
	instanceVariableNames: ''
	classVariableNames: 'ICUInterfaceClass ISO8601DATEFORMAT RFC1123DATEFORMAT RFC1123UTCDATEFORMAT RFC822DATEFORMAT UCAL_AM_PM UCAL_APRIL UCAL_AUGUST UCAL_DATE UCAL_DAY_OF_MONTH UCAL_DAY_OF_WEEK UCAL_DAY_OF_WEEK_IN_MONTH UCAL_DAY_OF_YEAR UCAL_DECEMBER UCAL_DEFAULT UCAL_DOW_LOCAL UCAL_DST_OFFSET UCAL_ERA UCAL_EXTENDED_YEAR UCAL_FEBRUARY UCAL_FIELD_COUNT UCAL_FRIDAY UCAL_GREGORIAN UCAL_HOUR UCAL_HOUR_OF_DAY UCAL_IS_LEAP_MONTH UCAL_JANUARY UCAL_JULIAN_DAY UCAL_JULY UCAL_JUNE UCAL_MARCH UCAL_MAY UCAL_MILLISECOND UCAL_MILLISECONDS_IN_DAY UCAL_MINUTE UCAL_MONDAY UCAL_MONTH UCAL_NOVEMBER UCAL_OCTOBER UCAL_SATURDAY UCAL_SECOND UCAL_SEPTEMBER UCAL_SUNDAY UCAL_THURSDAY UCAL_TRADITIONAL UCAL_TUESDAY UCAL_UNDECIMBER UCAL_WEDNESDAY UCAL_WEEK_OF_MONTH UCAL_WEEK_OF_YEAR UCAL_YEAR UCAL_YEAR_WOY UCAL_ZONE_OFFSET UCAL_ZONE_TYPE_ANY UCAL_ZONE_TYPE_CANONICAL UCAL_ZONE_TYPE_CANONICAL_LOCATION UDAT_IGNORE U_BUFFER_OVERFLOW_ERROR U_CHAR_NAME_ALIAS U_CHAR_NAME_CHOICE_COUNT U_EXTENDED_CHAR_NAME U_UNICODE_10_CHAR_NAME U_UNICODE_CHAR_NAME'
	poolDictionaries: ''
	category: 'ICU-V2-Base'!

!ICUV2Constants class methodsFor: 'initialize' stamp: 'MartenFeldtmann 9/4/2012 10:01'!
initialize

	self initializeCalendarConstants ! !

!ICUV2Constants class methodsFor: 'initialize' stamp: 'MartenFeldtmann 9/11/2012 10:44'!
initializeCalendarConstants
	"self initializeCalendarConstants"
	
	RFC822DATEFORMAT := 'E, dd MMM yy HH:mm:ssZZZ'.
	RFC1123DATEFORMAT := 'E, dd MMM yyyy HH:mm:ssZZZ'.
	RFC1123UTCDATEFORMAT := 'E, dd MMM yyyy HH:mm:ssZZZZ'.
	ISO8601DATEFORMAT := 'YYYY-MM-dd''T''HH:mm:ss.SSSZZZZZ'.
	
	U_UNICODE_CHAR_NAME := 0.
	U_UNICODE_10_CHAR_NAME := 1.
	U_EXTENDED_CHAR_NAME := 2.
	U_CHAR_NAME_ALIAS := 3.
	U_CHAR_NAME_CHOICE_COUNT := 4.
	
	UCAL_ERA := 0.
	UCAL_YEAR := 1.
	UCAL_MONTH := 2.
	UCAL_WEEK_OF_YEAR := 3.
	UCAL_WEEK_OF_MONTH := 4.
	UCAL_DATE := 5.
	UCAL_DAY_OF_YEAR := 6.
	UCAL_DAY_OF_WEEK := 7.
	UCAL_DAY_OF_WEEK_IN_MONTH := 8.
	UCAL_AM_PM := 9.
	UCAL_HOUR := 10.
	UCAL_HOUR_OF_DAY := 11.
	UCAL_MINUTE := 12.
	UCAL_SECOND := 13.
	UCAL_MILLISECOND := 14.	
	UCAL_ZONE_OFFSET := 15.
	UCAL_DST_OFFSET := 16.
	UCAL_YEAR_WOY := 17.
	UCAL_DOW_LOCAL := 18.
	UCAL_EXTENDED_YEAR := 19.
	UCAL_JULIAN_DAY := 20.
	UCAL_MILLISECONDS_IN_DAY := 21.
	UCAL_IS_LEAP_MONTH := 22.
	UCAL_FIELD_COUNT := 23.
	UCAL_DAY_OF_MONTH := 5.
	
	
	U_BUFFER_OVERFLOW_ERROR := 15.
	
	UCAL_TRADITIONAL := 0.
	UCAL_DEFAULT := 0.
	UCAL_GREGORIAN := 1.
	
	UDAT_IGNORE := -2.
	
	UCAL_ZONE_TYPE_ANY := 0.
	UCAL_ZONE_TYPE_CANONICAL := 1.
	UCAL_ZONE_TYPE_CANONICAL_LOCATION := 2.
	
	
	
	
	
	! !

OSInt32 subclass: #UErrorCode
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-Base'!

!UErrorCode methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 19:20'!
failure

	^self status > 0! !

!UErrorCode methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 10:04'!
isBufferOverflowError

	^self status = U_BUFFER_OVERFLOW_ERROR! !

!UErrorCode methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 10:03'!
status

	^self at: 0! !

!UErrorCode methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 19:20'!
success

	^self status <= 0! !

OSStructure subclass: #UParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-Base'!

Object subclass: #UTextLocation
	instanceVariableNames: 'start end text'
	classVariableNames: ''
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-Base'!

!UTextLocation class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 12:08'!
start: startIndex end: endIndex text: string

	^self new
		start: startIndex;
		end: endIndex;
		text: string;
		yourself! !

!UTextLocation class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 12:08'!
start: startIndex length: length text: string

	^self new
		start: startIndex;
		length: length;
		text: string;
		yourself! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
end
	^ end! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
end: anObject
	end := anObject! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
start
	^ start! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
start: anObject
	start := anObject! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
text
	^ text! !

!UTextLocation methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 12:07'!
text: anObject
	text := anObject! !
ICUV2Constants initialize!
